unit Unit430;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, AdvUtil, Vcl.Grids, AdvObj, BaseGrid,
  AdvGrid, Vcl.StdCtrls;

type
  TForm430 = class(TForm)
    grid: TAdvStringGrid;
    CheckBox1: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure GridGetEditorProp(Sender: TObject; ACol, ARow: Integer;
      AEditLink: TEditLink);
    procedure GridGetEditorType(Sender: TObject; ACol, ARow: Integer;
      var AEditor: TEditorType);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form430: TForm430;

implementation

{$R *.dfm}

procedure TForm430.CheckBox1Click(Sender: TObject);
begin
  grid.MouseActions.DirectEdit := CheckBox1.Checked;
end;

procedure TForm430.FormCreate(Sender: TObject);
var
  x: Integer;
begin

  grid.Options := [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine,
    goRangeSelect, goEditing, goTabs];

  grid.MouseActions.DirectEdit := True;

  grid.RowCount := 20;
  grid.ColCount := 20;

  for x := 0 to grid.ColCount - 1 do
    grid.Cells[x, 0] := 'Col' + x.ToString;

  grid.RandomFill(false, 9999);

  grid.HideColumn(1);
  grid.HideColumn(3);
end;

procedure TForm430.GridGetEditorProp(Sender: TObject; ACol, ARow: Integer;
  AEditLink: TEditLink);
var
  c: char;
begin
  if ACol = 5 then
  begin
    grid.ClearComboString;
    for c := 'A' to 'Z' do
      grid.Combobox.Items.Add(c);
    grid.SetComboSelectionString('A');
  end;

end;

procedure TForm430.GridGetEditorType(Sender: TObject; ACol, ARow: Integer;
  var AEditor: TEditorType);
begin
  if ACol = 5 then
    AEditor := edComboList;
end;

end.
